%define anolis_release 4
%bcond_without perl_Compress_Raw_Zlib_enables_optional_test
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(CompTestUtils\\)
%global __provides_exclude_from %{?__provides_exclude_from:%__provides_exclude_from|}^%{_libexecdir}
%if %{defined perl_bootstrap}
%global __requires_exclude %{__requires_exclude}|^perl\\(Test::Builder)\s*$
%global __requires_exclude %{__requires_exclude}|^perl\\(Test::More)\s*$
%global __requires_exclude %{__requires_exclude}|^perl\\(Test::Simple)\s*$
%endif

Name:           perl-Compress-Raw-Zlib
Version:        2.202
Release:        %{anolis_release}%{?dist}
Summary:        Low-level interface to the zlib compression library
License:        (GPL-1.0-or-later OR Artistic-1.0-Perl) AND Zlib
URL:            https://metacpan.org/release/Compress-Raw-Zlib
Source0:        https://cpan.metacpan.org/modules/by-module/Compress/Compress-Raw-Zlib-%{version}.tar.gz

# Module Build
BuildRequires:  make gcc findutils coreutils
BuildRequires:  zlib-devel >= 1.2.1 perl-devel
BuildRequires:  perl-interpreter perl-generators
BuildRequires:  perl(vars) perl(lib) perl(Config)
BuildRequires:  perl(ExtUtils::Install) perl(ExtUtils::Constant) perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:  perl(File::Spec::Functions) perl(File::Copy)
# Module Runtime
BuildRequires:  perl(XSLoader) perl(warnings) perl(strict) 
BuildRequires:  perl(Exporter) perl(constant) perl(Carp) perl(bytes)
# Test Suite
BuildRequires:  perl(threads::shared) perl(File::Path)
%if %{with perl_Compress_Raw_Zlib_enables_optional_test}
# Optional Tests
BuildRequires:  perl(overload) perl(lib) perl(File::Temp)
# Dual-lived module needs rebuilding early in the boot process
%if !%{defined perl_bootstrap}
# Release tests are deleted
BuildRequires:  perl(Test::NoWarnings)
%endif
%endif
# Dual-lived module needs rebuilding early in the boot process
%if !%{defined perl_bootstrap}
BuildRequires:  perl(Test::More)
%endif

Requires:       perl(XSLoader)

# Don't "provide" private Perl libs
%{?perl_default_filter}

%description
The Compress::Raw::Zlib module provides a Perl interface to the zlib
compression library, which is used by IO::Compress::Zlib.

%package tests
Summary:        Tests for %{name}
Requires:       %{name} = %{EVR}
Requires:       perl-Test-Harness
%if %{with perl_Compress_Raw_Zlib_enables_optional_test}
# Optional Tests
Requires:       perl(overload) perl(File::Temp)
# Dual-lived module needs rebuilding early in the boot process
%if !%{defined perl_bootstrap}
Requires:       perl(Test::NoWarnings)
%endif
%endif

%description tests
Tests from %{name}-%{version}. Execute them
with "%{_libexecdir}/%{name}/test".

%package doc
Summary:        Doc files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description doc
Doc files for %{name}

%prep
%autosetup -p1 -n Compress-Raw-Zlib-%{version}
# Remove bundled zlib
rm -rf zlib-src
perl -i -ne 'print $_ unless m{^zlib-src/}' MANIFEST

%if !%{defined perl_bootstrap}
# Remove bundled Test::* modules
rm -rf t/Test
perl -i -ne 'print $_ unless m{^t/Test/}' MANIFEST
%endif

# Help file to recognise the Perl scripts
for F in t/*.t; do
    perl -i -MConfig -ple 'print $Config{startperl} if $. == 1' "$F"
    chmod +x "$F"
done

# Remove release tests
rm t/99pod.t t/meta-*.t
perl -i -ne 'print $_ unless m{^t/99pod\.t}' MANIFEST
perl -i -ne 'print $_ unless m{^t/meta-.*\.t}' MANIFEST

%build
OLD_ZLIB=False
BUILD_ZLIB=False 
ZLIB_LIB=%{_libdir}
ZLIB_INCLUDE=%{_includedir}
export BUILD_ZLIB OLD_ZLIB ZLIB_LIB ZLIB_INCLUDE
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}" NO_PACKLIST=1 NO_PERLLOCAL=1
%make_build

%install
%make_install
find %{buildroot} -type f -name '*.bs' -empty -delete

# Install tests
mkdir -p %{buildroot}/%{_libexecdir}/%{name}
install -m 0755 -p t/000prereq.t %{buildroot}/%{_libexecdir}/%{name}/000prereq.t
install -m 0755 -p t/01version.t %{buildroot}/%{_libexecdir}/%{name}/01version.t
install -m 0755 -p t/02zlib.t %{buildroot}/%{_libexecdir}/%{name}/02zlib.t
install -m 0755 -p t/07bufsize.t %{buildroot}/%{_libexecdir}/%{name}/07bufsize.t
install -m 0755 -p t/09limitoutput.t %{buildroot}/%{_libexecdir}/%{name}/09limitoutput.t
install -m 0755 -p t/18lvalue.t %{buildroot}/%{_libexecdir}/%{name}/18lvalue.t
install -m 0755 -p t/19nonpv.t %{buildroot}/%{_libexecdir}/%{name}/19nonpv.t
mkdir -p %{buildroot}/%{_libexecdir}/%{name}/compress
install -m 0755 -p t/compress/CompTestUtils.pm %{buildroot}/%{_libexecdir}/%{name}/compress/CompTestUtils.pm
perl -i -pe "s{DIR => '.'}{DIR => '/tmp'}" %{buildroot}/%{_libexecdir}/%{name}/t/compress/CompTestUtils.pm
cat > %{buildroot}/%{_libexecdir}/%{name}/test << 'EOF'
#!/bin/sh
unset PERL_CORE
cd %{_libexecdir}/%{name} && exec prove -I . -j "$(getconf _NPROCESSORS_ONLN)"
EOF
chmod +x %{buildroot}/%{_libexecdir}/%{name}/test

%{_fixperms} -c %{buildroot}

%check
unset PERL_CORE
export HARNESS_OPTIONS=j$(perl -e 'if ($ARGV[0] =~ /.*-j([0-9][0-9]*).*/) {print $1} else {print 1}' -- '%{?_smp_mflags}')
make test COMPRESS_ZLIB_RUN_MOST=1

%files
%{perl_vendorarch}/auto/Compress/
%{perl_vendorarch}/Compress/
%{_mandir}/man3/Compress::Raw::Zlib.3*

%files tests
%{_libexecdir}/%{name}

%files doc
%doc Changes README

%changelog
* Wed Apr 12 2023 Guyu Wang <guyu.wgy@linux.alibaba.com> - 2.202-4
- optimise spec file

* Tue Feb 07 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.202-3
- rebuild with perl_bootstrap disabled

* Mon Jan 30 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.202-2
- rebuild with perl 5.36.0

* Thu Dec 15 2022 Funda Wang <fundawang@yeah.net> - 2.202-1
- New version 2.202

* Wed Apr 20 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.103-1
- init from upstream
